local idle = true

function onCreate()
    
        makeAnimatedLuaSprite('cat', 'stages/bigotes/BG_TORNADO', -1000, 600);
        scaleObject('cat', 0.5,0.5)
        addAnimationByPrefix('cat', 'idle', 'Bango cat idle dance', 24, false)
        addAnimationByPrefix('cat', 'down', 'Bango cat down note', 24, false)
        addAnimationByPrefix('cat', 'up', 'Bango cat Up note', 24, false)
        addAnimationByPrefix('cat', 'left', 'Bango cat left note', 24, false)
        addAnimationByPrefix('cat', 'right', 'Bango cat Right note', 24, false)
        objectPlayAnimation('cat', 'idle')
        setObjectCamera('cat', 'other')
        addLuaSprite('cat', true)

        makeAnimatedLuaSprite('catmiss', 'stages/bigotes/BiGote', 10, 600);
        scaleObject('catmiss', 0.5,0.5)
        addAnimationByPrefix('catmiss', 'idle', 'Bango cat idle dance', 24, false)
        addAnimationByPrefix('catmiss', 'down', 'Bango cat down note', 24, false)
        addAnimationByPrefix('catmiss', 'up', 'Bango cat Up note', 24, false)
        addAnimationByPrefix('catmiss', 'left', 'Bango cat left note', 24, false)
        addAnimationByPrefix('catmiss', 'right', 'Bango cat Right note', 24, false)
        objectPlayAnimation('catmiss', 'idle')
        setObjectCamera('catmiss', 'other')
        addLuaSprite('catmiss', true)
        setProperty('catmiss.visible', false)

        makeLuaSprite('glow', 'bongo glow', -70, 530);
        scaleObject('glow', 0.5,0.5)
        setObjectCamera('glow', 'other')
        addLuaSprite('glow', false)
        setProperty('glow.visible', true)
        doTweenAlpha('glowout', 'glow', 0, 0.0001, 'linear')

        makeLuaSprite('catmissover', 'stages/SkyFire/gorefield_clouds_3', 50, 590);
        scaleObject('catmissover', 0.5,0.5)
        setObjectCamera('catmissover', 'other')
        addLuaSprite('catmissover', true)
        setProperty('catmissover.visible', false)
        
        
end
function onStartCountdown()
    doTweenX('catslidein', 'cat', 10, 2 , 'sineOut')
    return Function_Continue;
    
end
function onUpdate()
    
    if keyPressed('left') then
        setProperty('cat.visible', true)
        setProperty('catmissover.visible', false)
        objectPlayAnimation('catmiss', 'left')
        objectPlayAnimation('cat', 'left')
        setProperty('cat.x', -4)
        setProperty('cat.y', 600)
        idle = false
        
    end
    if keyReleased('left') then        
        idle = true
    end

    if keyPressed('down') then
        setProperty('catmissover.visible', false)
        setProperty('cat.visible', true)
        objectPlayAnimation('catmiss', 'down')
        objectPlayAnimation('cat', 'down')
        setProperty('cat.x', 11.5)
        setProperty('cat.y', 600)
        idle = false
    end
    if keyReleased('down') then
        idle = true
    end

    if keyPressed('up') then
        setProperty('catmissover.visible', false)
        setProperty('cat.visible', true)
        objectPlayAnimation('catmiss', 'up')
        objectPlayAnimation('cat', 'up')
        setProperty('cat.x', 3)
        setProperty('cat.y', 597)
        idle = false
    end
    if keyReleased('up') then
        idle = true
    end


    if keyPressed('right') then
        setProperty('catmissover.visible', false)
        setProperty('cat.visible', true)
        objectPlayAnimation('catmiss', 'right')
        objectPlayAnimation('cat', 'right')
        setProperty('cat.x', -1)
        setProperty('cat.y', 600)
        idle = false
    end
    if keyReleased('right') then
        idle = true
    end
end

function noteMiss(id, direction, noteType, isSustainNote)
    idle = false
    runTimer('idle', 0.5)
    if direction == 0 then
        doTweenX('catmissoverleft', 'catmissover', 50, 0.2, 'sineOut')
        setProperty('catmissover.x', 40)
        setProperty('catmissover.y', 590)
        objectPlayAnimation('catmiss', 'left')
        setProperty('catmiss.x', -4)
        setProperty('catmiss.y', 600)
    end

    if direction == 1 then
        objectPlayAnimation('catmiss', 'down')
        setProperty('catmiss.x', 11.5)
        doTweenY('catmissoverdown', 'catmissover', 591, 0.2, 'sineOut')
        setProperty('catmissover.x', 50)
        setProperty('catmissover.y', 600)
    end

    if direction == 2 then
        doTweenY('catmissoverup', 'catmissover', 589, 0.2, 'sineOut')
        setProperty('catmissover.x', 50)
        setProperty('catmissover.y', 580)
        objectPlayAnimation('catmiss', 'up')
        setProperty('catmiss.x', 3)
        setProperty('catmiss.y', 597)
    end
    if direction == 3 then
        objectPlayAnimation('catmiss', 'right')
        setProperty('catmiss.x', -1)
        setProperty('catmiss.y', 600)
        doTweenX('catmissoverright', 'catmissover', 50, 0.2, 'sineOut')
        setProperty('catmissover.x', 60)
        setProperty('catmissover.y', 590)
    end
    setProperty('catmissover.visible', true)
    setProperty('catmiss.visible', true)
    setProperty('cat.visible', false)
end


function onTimerCompleted(tag)
    if tag == 'idle' then
        idle = true
        setProperty('catmissover.visible', false)
        setProperty('catmiss.visible', false)
        setProperty('cat.x', 10)
        setProperty('cat.y', 600)
        setProperty('cat.visible', true)
        setProperty('catmissover.x', 50)
        setProperty('catmissover.y', 590)
    end
end

function onStepHit()
    if curStep == 1008 then
        doTweenAlpha('glowin', 'glow', 1, 1, 'linear')
    end

end

function onBeatHit()
    if idle == true then
        if curBeat %4 == 2 then
        setProperty('cat.x', 10)
        setProperty('cat.y', 600)
        objectPlayAnimation('cat', 'idle', true)
        end
    end
end



-- by latter
YX = false
keep = false
function onCreatePost()
setProperty('healthBarBG.color', getColorFromHex ('000000'))
end
the_angle_shake = 0
--icon and healthBar movement
function onUpdatePost()
the_angle_shake = math.random(1,2)

setProperty('healthBar.offset.x', getProperty('healthBarBG.offset.x'))

setProperty('healthBar.offset.y', getProperty('healthBarBG.offset.y'))
if keep then
setProperty('iconP1.offset.x', getProperty('healthBarBG.offset.x'))
setProperty('iconP1.offset.y', getProperty('healthBarBG.offset.y'))
end

if songName == 'Final-Fight' then

setProperty('iconP2.offset.x', getProperty('healthBarBG.offset.x'))
setProperty('iconP2.offset.y', getProperty('healthBarBG.offset.y') + 20)--iconP2 is fucked lol

elseif songName == 'Rooten-Family' then
setProperty('iconP2.offset.x', getProperty('healthBarBG.offset.x') + 10)
setProperty('iconP2.offset.y', getProperty('healthBarBG.offset.y'))

elseif songName == 'fashioned-values' then
setProperty('iconP1.offset.x', 40)

if dadName == 'Retep' then

setProperty('iconP2.offset.x', getProperty('healthBarBG.offset.x') + 40)
setProperty('iconP2.offset.y', getProperty('healthBarBG.offset.y') + 15)

elseif dadName == 'Retep and Cleveland' then
setProperty('iconP2.offset.x', getProperty('healthBarBG.offset.x') + 80)
setProperty('iconP2.offset.y', getProperty('healthBarBG.offset.y') + 30)

end

elseif songName == 'Twinkle' then
setProperty('iconP2.offset.x', getProperty('healthBar.offset.x') + 10)
setProperty('iconP2.offset.y', getProperty('healthBar.offset.y'))
setProperty('iconP1.offset.x', getProperty('healthBar.offset.x') - 5)
setProperty('iconP1.offset.y', getProperty('healthBar.offset.y') + 5)

elseif songName == 'A-Family-Guy' then
setProperty('iconP2.offset.x', getProperty('healthBar.offset.x') + 25)

setProperty('iconP1.offset.x', getProperty('healthBar.offset.x') - 15)

elseif songName == 'Airborne' then
setProperty('iconP2.offset.y', getProperty('healthBar.offset.y') + 30)
setProperty('iconP2.offset.x', getProperty('healthBar.offset.x') + 30)

else
setProperty('iconP2.offset.x', getProperty('healthBar.offset.x'))
setProperty('iconP2.offset.y', getProperty('healthBar.offset.y'))


end

		doTweenAngle('bf', 'iconP1', 0, 0.3, 'linear')
doTweenX('dodo', 'iconP1.scale', 1, 0.2, 'linear')
if getProperty('health') <= 0.4 then
		doTweenAngle('boyfren', 'iconP1', getRandomFloat(-10, 10), 0.01, 'linear')
elseif getProperty('health') >= 1.63 then
		doTweenAngle('dad', 'iconP2', getRandomFloat(-10, 10), 0.01, 'linear')
else

		doTweenAngle('dad', 'iconP2', 0, 0.01, 'linear')

end



if YX then
doTweenY('dhdY', 'healthBarBG.offset', getRandomFloat(-30, 30), 0.01, 'linear')
doTweenX('dhdX', 'healthBarBG.offset', getRandomFloat(-30, 30), 0.01, 'linear')


end
end

--iconP1 bounce on beat iconP2 shake on beat

function onBeatHit()
if curBeat %2 == 0 then
YX = true
runTimer('YXC', 0.1)
	setProperty('iconP1.scale.x', 1.5);
	setProperty ('iconP1.angle', 20)

else
	setProperty('iconP1.scale.x', 0.5);
	setProperty ('iconP1.angle', -20)
YX = true
runTimer('YXC', 0.1)
end
end
shakeico = false
function noteMiss(id, direction, noteType, isSustainNote)
if shakeico then
triggerEvent('icons')
end
if songName == 'A-Family-Guy' then
if curStep < 1085 or curStep > 1217 then
triggerEvent('icons')

end
end
end

function onStepHit()
if songName == 'Rooten-Family' then
if curStep == 130 then
shakeico = true
elseif curStep == 252 then
shakeico = false
elseif curStep == 508 then
shakeico = true
elseif curStep == 764 then
shakeico = false
end
end
if songName == 'fashioned-values' then
if curStep == 68 then
shakeico = true
elseif curStep == 512 then
shakeico = false
elseif curStep == 646 then
shakeico = true
elseif curStep == 1172 then
shakeico = false
elseif curStep == 1414 then
shakeico = true
elseif curStep == 1532 then
shakeico = false
end
end
if songName == 'Twinkle' then
if curStep == 256 then
shakeico = true
elseif curStep == 1019 then
shakeico = false
elseif curStep == 1166 then
shakeico = true
elseif curStep == 1918 then
shakeico = false
elseif curStep == 2460 then
shakeico = true
elseif curStep == 2683 then
shakeico = false
end
end
end

function onEvent(name,value1,value2)
if name == 'icons' then
if getProperty('iconP1.alpha') == 1 or getProperty('iconP1.visible') == true then

setProperty('iconP1.color', getColorFromHex('FF0007'))
doTweenColor('back1', 'iconP1', 'ffffff', 0.2, 'linear')


keep = true
YX = true
runTimer('keeptr', 0.1)
end
end
end

-- return iconP2 to normal
function onTimerCompleted(tag)
if tag == 'YXC' then

doTweenY('dhY2', 'healthBarBG.offset',0, 0.01, 'linear')
doTweenX('dhX2', 'healthBarBG.offset',0, 0.01, 'linear')

YX = false

end
if tag == 'keeptr' then
doTweenY('dhY2', 'healthBarBG.offset',0, 0.01, 'linear')
doTweenX('dhX2', 'healthBarBG.offset',0, 0.01, 'linear')
YX = false
keep = false
end
end



-- double note shake effect
function opponentNoteHit(id, direction, noteType, isSustainNote)
	if Du == getPropertyFromGroup('notes', id, 'strumTime') and not isSustainNote then

cameraShake('camHUD', 0.05, 0.05)
cameraShake('camGame', 0.05, 0.05)
if the_angle_shake == 1 then
setProperty('camGame.angle', 10)
setProperty('camHUD.angle', 10)
else
setProperty('camGame.angle', -10)
setProperty('camHUD.angle', -10)
end
doTweenAngle('bduew to ok wuwhw5ejs', 'camHUD', 0, 0.1, 'circOut')
doTweenAngle('bduew to ok wuwhw5efjs', 'camGame', 0, 0.1, 'circOut')
elseif Du == getPropertyFromGroup('notes', id, 'strumTime') and isSustainNote then
cameraShake('camHUD', 0.02, 0.02)
cameraShake('camGame', 0.02, 0.02)

	end
		Du = getPropertyFromGroup('notes', id, 'strumTime')
	end
	