--[[
	It's basically my (raltyro) modchart template that does cool cameras stuff
	but only the cameras
	
	doesnt support shake different axes, sorry, linc_luajit doesnt support haxe enums
	
	IM SORRY BUT IT HAD TO BE AN CUSTOM EVENT SCRIPT
	BECAUSE CUSTOM EVENT SCRIPT COMES LAST TO UPDATE
	xoxo raltyro uwu
--]]

-- if you want to setting the camera stuff like shake. you can do it here
local config = {
	betterShake = false,
	betterShakeHardness = .5, -- from 0 to 1
	betterShakeFadeTime = .15,
	useScrollForShake = false
}


------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------
----------------------------------------- NO TOUCH :< ------------------------------------------
------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------
local clock = 0

-- LUA 5.3 FUNCTIONS
function table.find(table,v)
	for i,v2 in next,table do
		if v2 == v then
			return i
		end
	end
end

function table.clear(t)
	while #t ~= 0 do rawset(t, #t, nil) end
end

function math.clamp(x,min,max)return math.max(min,math.min(x,max))end

-- INITIAL FUNCTIONS
local tableCopy
function tableCopy(t,st,copyMeta,x)
	if (copyMeta == nil) then copyMeta = true end
	x = x or 0
	getfenv().things = getfenv().things or {}
	local things = getfenv().things
	if (things[t] ~= nil) then return things[t] end

	st = st or {}
	
	things[t] = st
	
	for i,v in pairs(t) do
		st[i] = type(v) == "table" and tableCopy(v,{},copyMeta,x + 1) or v
	end
	if (x <= 0) then getfenv().things = {} end
	
	if (copyMeta) then
		local meta = getmetatable(t)
		if (type(meta) == "table") then
			setmetatable(st, meta)
		end
	end
	
	return st
end

local function strthing(s,i)
	local str = ""
	for i = 1,i do
		str = str .. s
	end
	return str
end

function mathlerp(from,to,i)return from+(to-from)*i end

local isDead = false
function dead()
	return isDead or getProperty("isDead")
end

-- POINT FUNCTIONS
if (type(point) ~= "table" or point.userdata ~= "point") then
	point = {userdata = "point"}
	point.__index = point

	function point.new(x, y)
		return point.set(setmetatable({}, point), x, y)
	end

	function point.set(p, x, y)
		p.x = x or 0
		p.y = y or 0
		
		return p
	end
	
	function point.add(p, x, y)
		p.x = p.x + (x or 0)
		p.y = p.y + (y or 0)
		
		return p
	end
end

-- MATRIX FUNCTIONS
if (type(matrix) ~= "table" or matrix.userdata ~= "matrix") then
	matrix = {userdata = "matrix"}
	matrix.__index = matrix

	function matrix.new(a, b, c, d, tx, ty)
		return matrix.setTo(setmetatable({}, matrix), a, b, c, d, tx, ty)
	end
	
	function matrix.setTo(mat, a, b, c, d, tx, ty)
		mat.a = a or 1
		mat.b = b or 0
		mat.c = c or 0
		mat.d = d or 1
		mat.tx = tx or 0
		mat.ty = ty or 0
		
		return mat
	end

	function matrix.identity(mat)
		return matrix.setTo(mat)
	end

	function matrix.translate(mat, x, y)
		mat.tx, mat.ty = mat.tx + (x or 0), mat.ty + (y or 0)
		return mat
	end

	function matrix.scale(mat, sx, sy)
		sx = sx or 0
		sy = sy or 0
		
		mat.a = mat.a * sx
		mat.b = mat.b * sy
		mat.c = mat.c * sx
		mat.d = mat.d * sy
		mat.tx = mat.tx * sx
		mat.ty = mat.ty * sy
		
		return mat
	end

	function matrix.concat(mat, a, b, c, d, tx, ty)
		if (type(a) == "table") then
			return matrix.concat(mat, a.a, a.b, a.c, a.d, a.tx, a.ty)
		end
		
		local a1 = mat.a * a + mat.b * c
		mat.b = mat.a * b + mat.b * d
		mat.a = a1

		local c1 = mat.c * a + mat.d * c
		mat.d = mat.c * b + mat.d * d
		mat.c = c1

		local tx1 = mat.tx * a + mat.ty * c + tx
		mat.ty = mat.tx * b + mat.ty * d + ty
		mat.tx = tx1
		
		return mat
	end

	function matrix.rotate(mat, theta)
		local rad = math.rad(theta or 0)
		local rotCos, rotSin = math.cos(rad), math.sin(rad)
		
		local a1 = mat.a * rotCos - mat.b * rotSin
		mat.b = mat.a * rotSin + mat.b * rotCos
		mat.a = a1
		
		local c1 = mat.c * rotCos - mat.d * rotSin
		mat.d = mat.c * rotSin + mat.d * rotCos
		mat.c = c1
		
		local tx1 = mat.tx * rotCos - mat.ty * rotSin
		mat.ty = mat.tx * rotSin + mat.ty * rotCos
		mat.tx = tx1
		
		return mat
	end

	function matrix.skew(mat, x, y)
		local skb, skc = math.tan(math.rad(y or 0)), math.tan(math.rad(x or 0))
		
		mat.b = mat.a * skb + mat.b
		mat.c = mat.c + mat.d * skc
		
		mat.ty = mat.tx * skb + mat.ty
		mat.tx = mat.tx + mat.ty * skc
		
		return mat
	end
end

---------------------------------

local templateCam = {
	zoom = 1,
	
	visible = true,
	
	width = 1280,
	height = 720,
	
	scale = point.new(1, 1),
	
	spriteScale = point.new(1, 1),
	
	x = 0,
	y = 0,
	
	anchorPoint = point.new(.5, .5),
	offset = point.new(),
	
	-- Just incase if you want to mess around
	skew = point.new(),
	clipSkew = point.new(),
	
	transform = matrix.new(),
	_matrix = matrix.new(),
	
	viewOffset = point.new(),
	
	angle = 0,
	
	scrollOffset = point.new(),
	_lastScrollOffset = point.new(),
	
	ignoreScaleMode = false,
	
	fxShakeIntensity = 0,
	fxShakeDuration = -1000,
	fxShakeI = -999999
}

local defaultCams

local cams = {
	isReady = false,
	
	hud = tableCopy(templateCam),
	other = tableCopy(templateCam),
	game = tableCopy(templateCam)
}

function initializeCams()
	local function cam(t, cam, class)
		t.getProperty = type(class) == "string" and function(v)return getPropertyFromClass(class, cam .. "." .. v)end or
			function(v)return getProperty(cam .. "." .. v)end
		t.setProperty = type(class) == "string" and function(v, x)return setPropertyFromClass(class, cam .. "." .. v, x)end or
			function(v, x)return setProperty(cam .. "." .. v, x)end
		local getProperty = t.getProperty
		
		t.class = class
		t.cam = cam
	end
	
	cam(cams.hud, "camHUD")
	cam(cams.other, "camOther")
	cam(cams.game, "camera", "flixel.FlxG")
	
	cams.isReady = true
	
	defaultCams = tableCopy(cams)
end

function updateCam(t, dt)
	if (not cams.isReady) then return end
	
	local scaleModeX = t.ignoreScaleMode and 1 or getPropertyFromClass("flixel.FlxG", "scaleMode.scale.x")
	local scaleModeY = t.ignoreScaleMode and 1 or getPropertyFromClass("flixel.FlxG", "scaleMode.scale.y")
	local initialZoom = t.getProperty("initialZoom")
	
	local x = t.getProperty("x")
	local y = t.getProperty("y")
	
	t.zoom = t.getProperty("zoom")
	t.angle = t.getProperty("angle")
	t.width = t.getProperty("width")
	t.height = t.getProperty("height")
	
	local cool = (config.betterShake and -config.betterShakeFadeTime or 0)
	
	t.fxShakeDuration = t.fxShakeDuration > cool and t.fxShakeDuration - dt or cool
	
	local _fxShakeIntensity = t.getProperty("_fxShakeIntensity")
	local _fxShakeDuration = t.getProperty("_fxShakeDuration")
	if (_fxShakeIntensity > 0 and _fxShakeDuration > 0) then
		t.fxShakeIntensity = _fxShakeIntensity
		t.fxShakeDuration = _fxShakeDuration
		
		t.setProperty("_fxShakeIntensity", 0)
	end
	
	t.scale.x = t.getProperty("scaleX")
	t.scale.y = t.getProperty("scaleY")
	
	t.viewOffset.x = x
	t.viewOffset.y = y
	
	t.skew:set(0, 0)
	
	if (t.fxShakeDuration > cool) then
		local sX = t.fxShakeIntensity * t.width -- uwu~
		local sY = t.fxShakeIntensity * t.height
		
		local rX, rY, rAngle, rSkewX, rSkewY = 0, 0, 0, 0, 0
		if (config.betterShake) then
			local w = (t.fxShakeDuration / -cool) + 1
			local ww = math.clamp(w, 0, 1) * (-config.betterShakeHardness + 1)
			local www = math.clamp(w, 0, 1) * config.betterShakeHardness
			
			t.fxShakeI = t.fxShakeI + (math.clamp((t.fxShakeIntensity * 7) + .75, 0, 10) * dt * math.clamp(w, 0, 1.5))
			rX = math.cos(t.fxShakeI * 97) * sX * ww
			rY = math.sin(t.fxShakeI * 86) * sY * ww
			rAngle = math.sin(t.fxShakeI * 62) * math.clamp(t.fxShakeIntensity * 66, -60, 60) * ww
			rSkewX = math.cos(t.fxShakeI * 54) * math.clamp(t.fxShakeIntensity * 12, -4, 4) * ww
			rSkewY = math.sin(t.fxShakeI * 51) * math.clamp(t.fxShakeIntensity * 12, -1.5, 1.5) * ww
			
			if (config.betterShakeHardness > 0) then
				rX = rX + (math.cos(t.fxShakeI * 165) * sX * www)
				rY = rY + (math.cos(t.fxShakeI * 132) * sY * www)
				rAngle = rAngle + (math.sin(t.fxShakeI * 111) * math.clamp(t.fxShakeIntensity * 66, -60, 60) * www)
				rSkewX = rSkewX + (math.sin(t.fxShakeI * 123) * math.clamp(t.fxShakeIntensity * 12, -4, 4) * www)
				rSkewY = rSkewY + (math.cos(t.fxShakeI * 101) * math.clamp(t.fxShakeIntensity * 12, -1.5, 1.5) * www)
			end
		else
			rX = getRandomFloat(-sX, sX)
			rY = getRandomFloat(-sY, sY)
		end
		
		if (config.useScrollForShake and t == cams.game) then
			t.scrollOffset:set(
				rX,
				rY
			)
		else
			t.viewOffset:add(
				rX * t.zoom,
				rY * t.zoom
			)
		end
		t.angle = t.angle + rAngle
		t.skew:add(rSkewX, rSkewY)
	else
		t.scrollOffset:set(0, 0)
	end
	
	local scaleX = t.scale.x
	local scaleY = t.scale.y
	
	if (type(t.getProperty("canvas.x")) == "number") then
		local width = (t.width * t.spriteScale.x)
		local height = (t.height * t.spriteScale.y)
		
		local ratio = t.width / width
		
		local aW, aH = width*t.anchorPoint.x, height*t.anchorPoint.y
		
		-- TY https://community.openfl.org/t/rotation-around-center/8751/4
		
		-- Setup Matrix
		local mat = t._matrix
		mat:identity()
		
		mat:translate(-aW, -aH) -- AnchorPoint In
		
		mat:scale(scaleX, scaleY) -- Scaling
		
		mat:rotate(t.angle) -- Angle
		
		mat:skew(t.skew.x, t.skew.y)
		
		mat:translate(aW, aH) -- AnchorPoint Out
		
		mat:translate(t.viewOffset.x, t.viewOffset.y) -- Offset
		
		mat:scale(scaleModeX * t.spriteScale.x, scaleModeY * t.spriteScale.y) -- ScaleMode
		
		-- Finals
		t.setProperty("canvas.__transform.a", mat.a)
		t.setProperty("canvas.__transform.b", mat.b)
		t.setProperty("canvas.__transform.c", mat.c)
		t.setProperty("canvas.__transform.d", mat.d)
		t.setProperty("canvas.__transform.tx", mat.tx)
		t.setProperty("canvas.__transform.ty", mat.ty)
	end
	
	t.setProperty("flashSprite.rotation", 0)
	t.setProperty("flashSprite.x", 0)
	t.setProperty("flashSprite.y", 0)
	t.setProperty("_flashOffset.x", (t.width * .5) * scaleModeX * initialZoom - (x * scaleModeX))
	t.setProperty("_flashOffset.y", (t.height * .5) * scaleModeY * initialZoom - (y * scaleModeY))
	
	local x = getProperty("camFollowPos.x")
	if (t == cams.game and type(x) == "number") then
		setProperty("camFollowPos.x", x + t.scrollOffset.x)
		setProperty("camFollowPos.y", getProperty("camFollowPos.y") + t.scrollOffset.x)
	else
		t.setProperty("scroll.x", t.getProperty("scroll.x") + t.scrollOffset.x)
		t.setProperty("scroll.y", t.getProperty("scroll.y") + t.scrollOffset.y)
	end
	t._lastScrollOffset:set(t.scrollOffset.x, t.scrollOffset.y)
end

function updateCamEarly(t, dt)
	if (t == cams.game) then
		setProperty("camFollowPos.x", getProperty("camFollowPos.x") - t._lastScrollOffset.x)
		setProperty("camFollowPos.y", getProperty("camFollowPos.y") - t._lastScrollOffset.y)
	else
		t.setProperty("scroll.x", t.getProperty("scroll.x") - t._lastScrollOffset.x)
		t.setProperty("scroll.y", t.getProperty("scroll.y") - t._lastScrollOffset.y)
	end
end

function updateCamsEarly(dt)
	if (not dead()) then
		updateCamEarly(cams.hud, dt)
		updateCamEarly(cams.other, dt)
	end
	updateCamEarly(cams.game, dt)
end

function updateCams(dt)
	if (not dead()) then
		updateCam(cams.hud, dt)
		updateCam(cams.other, dt)
	end
	updateCam(cams.game, dt)
end

function onGameOverStart()
	isDead = true
end

function onCreate()
	clock = getRandomFloat(-2^12, 0)
	
	initializeCams()
end

function onUpdate(dt)
	clock = clock + dt
	
	updateCamsEarly(dt)
end

function onUpdatePost(dt)
	updateCams(dt)
end


offsetX = 20--offset for the X
offsetY = 20--offset for the Y

--i stole this lol

CLO = false--original cam switch from false or true
CLX = nil--original cam but X
CLY = nil--original cam but Y

P = nil-- detect if it's player or opponent

CPX = nil--this is the cam movement it self supported by the offsetX
CPY = nil--this is the cam movement it self supported by the offsetY

function onCreate()
if songName == 'Airborne' then--prevent airborne to have this screen movement because it's not necessary
airborne = true
else
airborne = false
end
if songName == 'Final-Fight' then
offsetX = 90--offset for the X
offsetY = 90--offset for the Y
end

if songName == 'Twinkle' then
offsetX = 40--offset for the X
offsetY = 40--offset for the Y
end
end

function onMoveCamera(focus)
if not airborne then--i don't want this for airborne
	CPX = getProperty('camFollow.x')
	CPY = getProperty('camFollow.y')

	if focus == 'boyfriend' then
		CLO = false
		P = 1

	elseif focus == 'dad' then
		CLO = false
		P = 2

	elseif focus == 'gf' then
		CLO = false

		if mustHitSection then--camera focus for gf, it depends if it's mustHitSection gf focus or other
			P = 1
		else
			P = 2
		end
	end
end
end

function onUpdatePost()
if not airborne then
--this is reset the offset without changing the actual tag it self
	if CLO == true then
		setProperty('camFollow.x', CLX)
		setProperty('camFollow.y', CLY)
	end
end
end


--bf and gf if camera focus on gf
function goodNoteHit(id, direction, noteType, isSustainNote)
if not airborne then
	if P == 1 then

		CLO = true
	if direction == 0 then
		CLX = CPX - offsetX
		CLY = CPY
	elseif direction == 1 then
		CLX = CPX
		CLY = CPY + offsetY
	elseif direction == 2 then
		CLX = CPX
		CLY = CPY - offsetY
	elseif direction == 3 then
		CLX = CPX + offsetX
		CLY = CPY
	else
		CLX = CPX
		CLY = CPY
end
end
end
end


--dad and gf if camera focus on gf
function opponentNoteHit(id, direction, noteType, isSustainNote)
if not airborne then
	if P == 2 then

		CLO = true
	if direction == 0 then
		CLX = CPX - offsetX
		CLY = CPY
	elseif direction == 1 then
		CLX = CPX
		CLY = CPY + offsetY
	elseif direction == 2 then
		CLX = CPX
		CLY = CPY - offsetY
	elseif direction == 3 then
		CLX = CPX + offsetX
		CLY = CPY
	else
		CLX = CPX
		CLY = CPY
end
end
end
end

function opponentNoteHit()
    health = getProperty('health')
    if getProperty('health') > 0.1 then
if dadName == 'gorefield-phase-0' then
        setProperty('health', health- 0.024);
elseif dadName == 'gorefield-phase-3' then
        setProperty('health', health- 0.02);
		doTweenColor('Q', 'd1', 'CC0000', 0.1, 'linear')
end
end
end

function onCreate()
addToList('Corruptgmire', 'dad')
addCharacterToList('quagmire2', 'boyfriend')
addCharacterToList('quagmirediff', 'boyfriend')

end

function onCreatePost()
makeAnimatedLuaSprite('boo', 'characters/gorefield-phase-3', getProperty('boyfriend.x') - 200, getProperty('boyfriend.y') - 300);
	addAnimationByPrefix('boo', 'IDLE', 'Idle', 24, true);

doTweenColor('b', 'boo', '000000', 0.01, 'linear')
setProperty('boo.flipX', true)
setProperty('boo.visible', false)
	scaleObject('boo', 6, 6);
	addLuaSprite('boo', false);
addLuaScript('data/airborne/white effect')
addLuaScript('custom_events/Black effect')
		makeLuaSprite('WBG', nil, 0, 0)
		makeGraphic('WBG',1280,720,'ffffff')
		addLuaSprite('WBG', false)
scaleObject('WBG', 1, 1);
setObjectCamera('WBG', 'other')
setProperty('WBG.alpha',0)
addLuaSprite('WBG', true)

doTweenZoom('cam', 'camGame', 50, 0.01, 'linear')
end

function onSongStart()


originaldadx = getProperty('dad.x')
originaldady = getProperty('dad.y')

originalbfx = getProperty('boyfriend.x')

originalgfx = getProperty('gf.x')
originalgfy = getProperty('gf.y')

originalClevx = getProperty('Cleveland.x')

doTweenZoom('cam', 'camGame', 0.71, 1, 'linear')
setProperty('boo.alpha', 0)
oy1 = getPropertyFromGroup('strumLineNotes', 4, 'y')
ox1 = getPropertyFromGroup('strumLineNotes', 4, 'x')
oy2 = getPropertyFromGroup('strumLineNotes', 5, 'y')
ox2 = getPropertyFromGroup('strumLineNotes', 5, 'x')
oy3 = getPropertyFromGroup('strumLineNotes', 6, 'y')
ox3 = getPropertyFromGroup('strumLineNotes', 6, 'x')
oy4 = getPropertyFromGroup('strumLineNotes', 7, 'y')
ox4 = getPropertyFromGroup('strumLineNotes', 7, 'x')

end

cutscene = 0

function onUpdate()

for n = 0,3 do
setPropertyFromGroup('strumLineNotes', n, 'alpha', 0)
end

if curStep < 1 then
setPropertyFromGroup('strumLineNotes', 4, 'x', 415)
setPropertyFromGroup('strumLineNotes', 5, 'x', 525)
setPropertyFromGroup('strumLineNotes', 6, 'x', 635)
setPropertyFromGroup('strumLineNotes', 7, 'x', 745)
end
if dadName == 'gorefield-phase-3' then
	setProperty('songLength', getProperty('songLength')+getRandomInt(11000, -10000))
end

if cutscene == 1 then
setProperty('camFollow.x', 2600)
setProperty('camFollow.y', 750)
elseif cutscene == 2 then--peter
setProperty('camFollow.x', 1350)
setProperty('camFollow.y', 750)
elseif cutscene == 3 then--joe
setProperty('camFollow.x', 1450)
setProperty('camFollow.y', 700)
elseif cutscene == 4 then--clev
setProperty('camFollow.x', 1300)
setProperty('camFollow.y', 800)

end
end

stp = 3
N = 0
C = true
effect = false
movecamer = false
follow = false
shake = false
gost = falseee
valnote = 69
function onStepHit()
if curStep %stp == 0 then
if effect == true then
triggerEvent('Add Camera Zoom', '0.2', '0.1')
triggerEvent('Weffect', '0.3')
doTweenAngle('2', 'camGame', 0, 0.5, 'quadInOut')
doTweenAngle('3', 'camHUD', 0, 0.5, 'quadInOut')
if N == 0 then
setProperty('camGame.angle', 10)
setProperty('camHUD.angle', 10)

N = 1
else
setProperty('camGame.angle', -10)
setProperty('camHUD.angle', -10)
N = 0
end
end

noteTweenY('BFY11',4, oy1 - getRandomInt(-valnote, valnote), 0.01, 'linear');
noteTweenX('BFX11',4, ox1 - getRandomInt(-valnote, valnote), 0.01, 'linear');
noteTweenY('BFY211',5, oy2 - getRandomInt(-valnote, valnote), 0.01, 'linear');
noteTweenX('BFX211',5, ox2 - getRandomInt(-valnote, valnote), 0.01, 'linear');
noteTweenY('BFY311',6, oy3 - getRandomInt(-valnote, valnote), 0.01, 'linear');
noteTweenX('BFX311',6, ox3 - getRandomInt(-valnote, valnote), 0.01, 'linear');
noteTweenY('BFY411',7, oy4 - getRandomInt(-valnote, valnote), 0.01, 'linear');
noteTweenX('BFX411',7, ox4 - getRandomInt(-valnote, valnote), 0.01, 'linear');


end
if curStep == 3 then
C = true

elseif curStep == 9 or curStep == 24 or curStep == 44 or curStep == 57 or curStep == 72 or curStep == 92 or curStep == 108 or curStep == 120 or curStep == 425 or curStep == 430 or curStep == 438 then
stp = 2

elseif curStep == 16 or curStep == 32 or curStep == 48 or curStep == 64 or curStep == 80 or curStep == 96 or curStep == 112 or curStep == 368 or curStep == 416 or curStep == 432 then
stp = 3

elseif curStep == 1 then
effect = false

elseif curStep == 126 then
effect = true
cameraFlash('camOther', 'ffffff', 1, true)
setProperty('defaultCamZoom', 0.61)

elseif curStep == 192 then
stp = 5
effect = false


doTweenAngle('2', 'camGame', 0, 0.5, 'quadInOut')
doTweenAngle('3', 'camHUD', 0, 0.5, 'quadInOut')
movecamer = true

setProperty('skystill.alpha', 0)
setProperty('sky.alpha', 1)

doTweenZoom('4', 'camGame', 1.5, 4, 'quadInOut')
doTweenAlpha('5', 'sky', 0, 0.5, 'quadInOut')
doTweenAlpha('6', 'Bg1', 0, 2, 'quadInOut')
doTweenAlpha('7', 'gf', 0, 2, 'quadInOut')
doTweenAlpha('8', 'boyfriend', 0, 2, 'quadInOut')
doTweenAlpha('9', 'Cleveland', 0, 2, 'quadInOut')

cutscene = 2

elseif curStep == 208 then
doTweenAlpha('92', 'Peter', 0, 1, 'quadInOut')
doTweenAlpha('7', 'Cleveland', 1, 1, 'quadInOut')
doTweenZoom('4', 'camGame', 1.5, 4, 'quadInOut')
cutscene = 4

elseif curStep == 224 then
doTweenAlpha('9', 'Cleveland', 0, 1, 'quadInOut')
doTweenAlpha('8', 'gf', 1, 1, 'quadInOut')
doTweenZoom('4', 'camGame', 1.5, 4, 'quadInOut')
cutscene = 3

elseif curStep == 256 then


doTweenZoom('4', 'camGame', 1.3, 1, 'quadInOut')
setProperty('defaultCamZoom', 1.3)
doTweenAlpha('8', 'gf', 0, 1, 'quadInOut')
stp = 3
effect = true
cutscene = 1

elseif curStep == 272 then
doTweenZoom('4', 'camGame', 1, 0.5, 'quadInOut')
setProperty('defaultCamZoom', 1)
doTweenAlpha('5', 'sky', 1, 0.5, 'quadInOut')
doTweenAlpha('6', 'Bg1', 1, 0.5, 'quadInOut')

doTweenAlpha('7', 'gf', 1, 0.5, 'quadInOut')
doTweenAlpha('8', 'boyfriend', 1, 0.5, 'quadInOut')
doTweenAlpha('9', 'Cleveland', 1, 0.5, 'quadInOut')
doTweenAlpha('10', 'Peter', 1, 0.5, 'quadInOut')
cutscene = 0

elseif curStep == 319 then
stp = 0
cameraFlash('camOther', 'ffffff', 1, true)
follow = false
effect = false
cutscene = false

elseif curStep == 320 then
doTweenAlpha('5', 'sky', 0, 4.5, 'quadInOut')
doTweenAlpha('6', 'Bg1', 0, 4.5, 'quadInOut')
doTweenAlpha('7', 'gf', 0, 4.5, 'quadInOut')
doTweenAlpha('8', 'boyfriend', 0, 4.5, 'quadInOut')
doTweenAlpha('9', 'Peter', 0, 4.5, 'quadInOut')

elseif curStep == 384 then
cutscene = 4

elseif curStep == 447 then
doTweenAlpha('iconP1', 'iconP1', 0, 0.001, 'linear')
		doTweenAlpha('healthBar', 'healthBar', 0, 0.001, 'linear')
		doTweenAlpha('timeTxt', 'timeTxt', 0, 0.001, 'linear')
		doTweenAlpha('timeBar', 'timeBar', 0, 0.001, 'linear')
		doTweenAlpha('newscoreTxt', 'newscoreTxt', 0, 0.001, 'linear')
		doTweenAlpha('iconP2', 'iconP2', 0, 0.001, 'linear')
		doTweenAlpha('healthBarBG', 'healthBarBG', 0, 0.001, 'linear')
		setObjectOrder('healthBarBG', 1)
    doTweenAlpha('heathly-bg', 'heathly-bg', 0, 0.001, 'linear')
    doTweenAlpha('heathly-bg-1', 'heathly-bg-1', 0, 0.001, 'linear')
    doTweenAlpha('heathly-bg-2', 'heathly-bg-2', 0, 0.001, 'linear')
    doTweenAlpha('HBA', 'HBA', 0, 0.001, 'linear')
    doTweenAlpha('d1', 'd1', 0, 0.001, 'linear')
    doTweenAlpha('d2', 'd2', 0, 0.001, 'linear')
    
elseif curStep == 450 then
doTweenAlpha('5', 'sky', 1, 0.5, 'quadInOut')
doTweenAlpha('6', 'Bg1', 1, 0.5, 'quadInOut')
cutscene = 4

elseif curStep == 512 then
cutscene = 0

elseif curStep == 544 then
doTweenAlpha('7', 'gf', 1, 2.5, 'quadInOut')
doTweenAlpha('8', 'Peter', 1, 2.5, 'quadInOut')
cutscene = 4

elseif curStep == 575 then
doTweenAlpha('7', 'boyfriend', 1, 1.5, 'quadInOut')
cutscene = 0

elseif curStep == 608 then
effect = true
cameraFlash('camOther', 'ffffff', 1, true)
setProperty('defaultCamZoom', 0.61)
doTweenAlpha('iconP1', 'iconP1', 1, 0.001, 'linear')
		doTweenAlpha('healthBar', 'healthBar', 1, 0.001, 'linear')
		doTweenAlpha('timeTxt', 'timeTxt', 1, 0.001, 'linear')
		doTweenAlpha('timeBar', 'timeBar', 1, 0.001, 'linear')
		doTweenAlpha('newscoreTxt', 'newscoreTxt', 1, 0.001, 'linear')
		doTweenAlpha('iconP2', 'iconP2', 1, 0.001, 'linear')
		doTweenAlpha('healthBarBG', 'healthBarBG', 1, 0.001, 'linear')
    doTweenAlpha('heathly-bg', 'heathly-bg', 1, 0.001, 'linear')
    doTweenAlpha('heathly-bg-1', 'heathly-bg-1', 1, 0.001, 'linear')
    doTweenAlpha('heathly-bg-2', 'heathly-bg-2', 1, 0.001, 'linear')
    doTweenAlpha('HBA', 'HBA', 1, 0.001, 'linear')
    doTweenAlpha('d1', 'd1', 1, 0.001, 'linear')
    doTweenAlpha('d2', 'd2', 1, 0.001, 'linear')
    
elseif curStep == 736 then
effect = false
doTweenAlpha('5', 'sky', 0, 0.5, 'quadInOut')
doTweenAlpha('6', 'Bg1', 0, 0.5, 'quadInOut')
triggerEvent('Change Character', 'boyfriend', 'bf-art')

elseif curStep == 864 then

setProperty('WBG.visible', false)
cameraFlash('camOther', 'ffffff', 1, true)
stp = 3
follow = false
effect = true
setProperty('boo.visible', true)

setProperty('quagmirecool.alpha', 0)
setProperty('sky.alpha', 1)
setProperty('effectd_Anm.alpha', 0.3)
setProperty('Bg1.alpha', 1)
setProperty('boyfriend.alpha', 1)
setProperty('gf.alpha', 1)
setProperty('Peter.alpha', 1)
setProperty('Cleveland.alpha', 1)
setProperty('dad.alpha', 1)
triggerEvent('Change Character', 'boyfriend', 'bf-black')
doTweenX('move4', 'gf', originalgfx, 0.01, 'linear')
doTweenY('move42', 'gf', originalgfy, 0.01, 'linear')
shake = true
setProperty('gf.x', originalgfx)
			for i = 0, getProperty('playerStrums.length')-1 do
				setPropertyFromGroup('playerStrums', i, 'texture', 'noteSkins/sans');
			end
change = true
doTweenAlpha('iconP1', 'iconP1', 1, 0.001, 'linear')
doTweenAlpha('healthBar', 'healthBar', 1, 0.001, 'linear')
doTweenAlpha('timeTxt', 'timeTxt', 1, 0.001, 'linear')
doTweenAlpha('timeBar', 'timeBar', 1, 0.001, 'linear')
doTweenAlpha('scoreTxt', 'scoreTxt', 1, 0.001, 'linear')
doTweenAlpha('iconP2', 'iconP2', 1, 0.001, 'linear')

elseif curStep == 1120 then
doTweenZoom('4', 'camGame', 0.81, 0.5, 'quadInOut')
setProperty('defaultCamZoom', 0.81)
cameraFlash('camOther', 'ffffff', 1, true)
stp = 5
cutscene = false

elseif curStep == 1135 then
doTweenZoom('4', 'camGame', 0.71, 0.5, 'quadInOut')
setProperty('defaultCamZoom', 0.71)

elseif curStep == 1150 then
doTweenZoom('4', 'camGame', 0.91, 0.5, 'quadInOut')
setProperty('defaultCamZoom', 0.91)

elseif curStep == 1165 then
doTweenZoom('4', 'camGame', 1.1, 0.5, 'quadInOut')
setProperty('defaultCamZoom', 1.1)

elseif curStep == 1185 then
doTweenZoom('4', 'camGame', 0.81, 0.5, 'quadInOut')
setProperty('defaultCamZoom', 0.81)
effect = true

elseif curStep == 1438 then
cameraFlash('camOther', 'ffffff', 10, true)

elseif curStep == 1238 then
triggerEvent('Change Character', 'boyfriend', 'bf')
doTweenColor('Joe', 'd2', '336699', 0.1, 'linear')
effect = false
stp = 0
shake = false


elseif curStep == 1245 then
setProperty('boyfriend.alpha', 0)
doTweenZoom('4', 'camGame', 0.71, 0.01, 'quadInOut')
setProperty('defaultCamZoom', 0.71)
cameraFlash('camOther', 'ffffff', 5, true)
doTweenAlpha('iconP1', 'iconP1', 0, 0.001, 'linear')
doTweenAlpha('healthBar', 'healthBar', 0, 0.001, 'linear')
doTweenAlpha('timeTxt', 'timeTxt', 0, 0.001, 'linear')
doTweenAlpha('timeBar', 'timeBar', 0, 0.001, 'linear')
doTweenAlpha('scoreTxt', 'scoreTxt', 0, 0.001, 'linear')
doTweenAlpha('iconP2', 'iconP2', 0, 0.001, 'linear')
change = false
removeLuaSprite('boo', true)
removeLuaSprite('Bg1', true)
removeLuaSprite('sky', true)
removeLuaSprite('quagmirecool', true)
setProperty('effectd_Anm.alpha', 0)
setProperty('white.alpha', 1)

doTweenColor('1c', 'Cleveland', '000000', 0.01, 'linear')
doTweenColor('2c', 'dad', '000000', 0.01, 'linear')

doTweenColor('3c', 'gf', '000000', 0.01, 'linear')
doTweenColor('4c', 'Peter', '000000', 0.01, 'linear')

setProperty('boyfriend.alpha', 0)

elseif curStep == 1501 then
setProperty('Bg2.alpha', 1)
setProperty('sparks.alpha', 1)
setProperty('hue.alpha', 1)
setProperty('Peter.alpha', 1)
setProperty('Cleveland.alpha', 1)
doTweenAlpha('c9', 'Peter', 1, 0.5, 'linear')
doTweenAlpha('c4', 'Cleveland', 1, 0.5, 'linear')
doTweenAlpha('ii', 'WBG', 1, 2.5, 'linear')
follow = false

elseif curStep == 1502 then
setProperty('camGame.alpha', 1)
triggerEvent('Change Character', 'dad', 'gorefield-phase-3')
triggerEvent('Change Character','2', 'jhon')
triggerEvent('Change Character', 'boyfriend', 'bf-blueblue')
setProperty('dad.alpha', 1)
removeLuaSprite('WBG', true)
removeLuaSprite('white', true)
cameraFlash('camOther', 'ffffff', 1, true)
doTweenAlpha('iconP1', 'iconP1', 1, 0.001, 'linear')
setProperty('Bg2.alpha', 1)
setProperty('sparks.alpha', 1)
setProperty('hue.alpha', 1)
setProperty('camGame.alpha', 1)
setProperty('dad.alpha', 1)
removeLuaSprite('WBG', true)
removeLuaSprite('white', true)
cameraFlash('camOther', 'ffffff', 1, true)
doTweenAlpha('iconP1', 'iconP1', 1, 0.001, 'linear')
doTweenAlpha('healthBar', 'healthBar', 1, 0.001, 'linear')
doTweenAlpha('timeTxt', 'timeTxt', 1, 0.001, 'linear')
doTweenAlpha('timeBar', 'timeBar', 1, 0.001, 'linear')
doTweenAlpha('scoreTxt', 'scoreTxt', 1, 0.001, 'linear')
doTweenAlpha('iconP2', 'iconP2', 1, 0.001, 'linear')
setProperty('effectd_Anm.alpha', 0.5)
effect = true
stp = 3
shake = true
doTweenColor('1c', 'Cleveland', '5B5B5B', 0.01, 'linear')
doTweenColor('4c', 'Peter', '5B5B5B', 0.01, 'linear')

follow = false

elseif curStep == 1787 then
effect = false

elseif curStep == 1810 then
effect = true
cameraFlash('camOther', 'ffffff', 1, true)
setProperty('defaultCamZoom', 0.61)

elseif curStep == 1840 then
cameraFlash('camOther', 'ffffff', 3, true)
setProperty('camGame.visible', false)
setProperty('camHUD.alpha', 0.5)
stp = 0
setProperty('oringpiss.alpha', 0.3)
doTweenColor('1c', 'Cleveland', '5B5B5B', 0.01, 'linear')
doTweenColor('4c', 'Peter', '5B5B5B', 0.01, 'linear')

elseif curStep == 1565 then
cutscene = 4

elseif curStep == 1683 then
cutscene = 0

elseif curStep == 1744 then
cutscene = 4

elseif curStep == 1764 then
cutscene = 0


end
end
function onSongStart()
originaldadx = getProperty('dad.x')
originaldady = getProperty('dad.y')
originalbfx = getProperty('boyfriend.x')
originalgfx = getProperty('gf.x')
originalgfy = getProperty('gf.y')
originalClevx = getProperty('Cleveland.x')
doTweenZoom('cam', 'camGame', 0.71, 1, 'linear')
setProperty('boo.alpha', 0)
oy1 = getPropertyFromGroup('strumLineNotes', 4, 'y')
ox1 = getPropertyFromGroup('strumLineNotes', 4, 'x')
oy2 = getPropertyFromGroup('strumLineNotes', 5, 'y')
ox2 = getPropertyFromGroup('strumLineNotes', 5, 'x')
oy3 = getPropertyFromGroup('strumLineNotes', 6, 'y')
ox3 = getPropertyFromGroup('strumLineNotes', 6, 'x')
oy4 = getPropertyFromGroup('strumLineNotes', 7, 'y')
ox4 = getPropertyFromGroup('strumLineNotes', 7, 'x')
end

function goodNoteHit(id, direction, noteType, isSustainNote)

if noteType == 'Orange' then
doTweenAlpha('b', 'boo', 0.5, 1, 'linear')
end

if change == true then
			for i = 0, getProperty('playerStrums.length')-1 do
if noteType == 'Orange' then

		setPropertyFromGroup('playerStrums', i, 'texture', 'noteSkins/sans');
else
		setPropertyFromGroup('playerStrums', i, 'texture', 'NOTE_assets');
end
end
end
end

function onTimerCompleted(t)
if t == 'moveo' then
doTweenX('move', 'dad', 910, 8.5, 'linear')
doTweenX('move2', 'Cleveland', 1933, 8.5, 'linear')

elseif t == 'moveo2' then

doTweenX('move3', 'boyfriend', 600, 14, 'linear')
doTweenX('move4', 'gf', 2230, 14, 'linear')

end
end

function onTweenCompleted(t)
if t == 'b' then
doTweenAlpha('b1', 'boo', 0, 1, 'linear')
gost = true
end
end

--BUDYN--

function onCreate()
    makeLuaText('healthText', 'Health: ' .. math.floor(getProperty("health") * 50), 300, screenWidth / 2 - -350 / 2, screenHeight / 2 - 430 / 1.5)
    addLuaText('healthText')
    setTextSize('healthText', 30);
  setPropertyFromClass('GameOverSubstate', 'characterName', 'bf');
setPropertyFromClass('GameOverSubstate', 'deathSoundName', 'fnf_loss_sfx');
end

function onUpdate(elapsed)
	-- start of "update", some variables weren't updated yet
    setTextString('healthText', '' .. math.floor(getProperty("health") * 50))

if getPropertyFromClass('ClientPrefs', 'downScroll') == false then
        setProperty('healthText.y', 630)
    end
end


